<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.*" %>
<%@ page import="com.alarmpoint.integrations.nnmi.NetworkNodeManagerScriptObject" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<jsp:useBean id="nnmNodeServiceBean"
             class="com.alarmpoint.integrations.nnmi.NetworkNodeManagerScriptObject"
             scope="session" />

<%
  /**
   * You can change these following variables to match the correct information, if necessary.
   */
  final int MAX_DISPLAY_CHARACTERS = 60;
  final int MAX_RECIPIENT_DISPLAY_CHARACTERS = 80;

  /**
   * this is the URL used to display the Group Search Window.
   * The directory structure should be based on the disk location, change if necessary.
   */
  
  final boolean QUERY_SOURCENODE_PREDICATE_VALUES = true;
  final String CATEGORY_PREDICATE_NAME = "category";
  final String FAMILY_PREDICATE_NAME = "family";
  final String NAME_PREDICATE_NAME = "name";
  final String NATURE_PREDICATE_NAME = "nature";
  final String PRIORITY_PREDICATE_NAME = "priority";
  final String SEVERITY_PREDICATE_NAME = "severity";
  final String SOURCENODENAME_PREDICATE_NAME = "sourcenodename";
  final String SOURCEOBJECTNAME_PREDICATE_NAME = "sourceobjectname";

  final String NNM_NODESERVICE_WS_URL = "http://192.168.168.121:8080/NodeBeanService/NodeBean";
  final String NNM_WS_USER = "webservices";
  final String NNM_WS_PASSWORD = "nnm";

  nnmNodeServiceBean.initializeClient(NNM_NODESERVICE_WS_URL, NNM_WS_USER, NNM_WS_PASSWORD);

%>


<subscription-panel xmlns:fi="http://apache.org/cocoon/forms/1.0#instance"
                    xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
					onload="onLoad();"
                    onsubmit="return validateForm(this);" 
					id="NNMSubscriptionForm">

<%
  // Set up the map for storing the currently selected values for each predicate
  final HashMap<String, ArrayList<String>> selectedPredicateValuesMap = new HashMap<String, ArrayList<String>>();
  // Set up map to find the Predicate model object based on its name
  final HashMap<String, PredicateBean> predicateNameMap = new HashMap<String, PredicateBean>();
  // Set up map that associates a predicate with the information it contributes to the summary page
  final HashMap<String, String> predicateSummaryNamesMap = new HashMap<String, String>();

  final StringBuffer summaryName = new StringBuffer();
  // collect the selected predicate values, and pre-populated values
  Iterator<PredicateBeanImpl> iterator = subscriptionBean.getPredicateIterator();
  while (iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     ArrayList<String> selectedValues = new ArrayList<String>();
     selectedValues.addAll(predicate.getSelectedValues());

     selectedPredicateValuesMap.put(predicate.getPredicateName(), selectedValues);
     predicateNameMap.put(predicate.getPredicateName(), predicate);

     if(!predicate.getSelectedValues().isEmpty())
     {
       summaryName.delete(0, summaryName.length());
       if(predicate.hasAnySelectedValue())
       {
         summaryName.append("ANY");
       }
       else
       {
         Iterator<String> valIter = predicate.getSelectedValues().iterator();
         while(valIter.hasNext())
         {
           summaryName.append(valIter.next());
           if(valIter.hasNext())
             summaryName.append(", ");
           if(summaryName.length() > MAX_DISPLAY_CHARACTERS)
           {
             summaryName.setLength(MAX_DISPLAY_CHARACTERS);
             break;
           }
         }
       }
       predicateSummaryNamesMap.put(predicate.getPredicateName(), summaryName.toString());
    }
  }

  final String subId = (String)request.getParameter("subscriptionId");
  final String subDomainId = (String)request.getParameter("subscriptionDomainId");
  final boolean creatingSubscription = (subId == null || "0".equals(subId)) || subDomainId == null;



  /**
   * This tab count will contain the total number tabs that will be displayed.
   */
  // The total number of tabs that will be displayed
  int tabCount = 4;
  if(creatingSubscription)
  {
    tabCount--;
  }
  if(subscriptionBean.isSelfSubscription())
  {
    tabCount--;
  }
  if(subscriptionBean.allOverridesSuppressed() && subscriptionBean.isTimeframeSuppressed())
  {
    tabCount--;
  }

  final HashMap<String, String> predicateLabelMap = new HashMap<String, String>();
  predicateLabelMap.put(CATEGORY_PREDICATE_NAME, "Category");
  predicateLabelMap.put(FAMILY_PREDICATE_NAME, "Family");
  predicateLabelMap.put(NAME_PREDICATE_NAME, "Incident Name");
  predicateLabelMap.put(NATURE_PREDICATE_NAME, "Nature");
  predicateLabelMap.put(PRIORITY_PREDICATE_NAME, "Priority");
  predicateLabelMap.put(SEVERITY_PREDICATE_NAME, "Severity");
  predicateLabelMap.put(SOURCENODENAME_PREDICATE_NAME, "Source Node Name");
  predicateLabelMap.put(SOURCEOBJECTNAME_PREDICATE_NAME, "Source Object Name");

  final HashMap<String, String> predicateValueMap = new HashMap<String, String>();
  predicateValueMap.put("com.hp.nms.incident.category.Fault", "Fault");
  predicateValueMap.put("com.hp.nms.incident.category.Status", "Status");
  predicateValueMap.put("com.hp.nms.incident.category.Config", "Config");
  predicateValueMap.put("com.hp.nms.incident.category.Accounting", "Accounting");
  predicateValueMap.put("com.hp.nms.incident.category.Performance", "Performance");
  predicateValueMap.put("com.hp.nms.incident.category.Security", "Security");
  predicateValueMap.put("com.hp.nms.incident.category.Alert", "Alert");
  predicateValueMap.put("com.hp.nms.incident.family.Address", "Address");
  predicateValueMap.put("com.hp.nms.incident.family.Interface", "Interface");
  predicateValueMap.put("com.hp.nms.incident.family.Node", "Node");
  predicateValueMap.put("com.hp.nms.incident.family.OSPF", "OSPF");
  predicateValueMap.put("com.hp.nms.incident.family.HSRP", "HSRP");
  predicateValueMap.put("com.hp.nms.incident.family.AggregatePort", "AggregatePort");
  predicateValueMap.put("com.hp.nms.incident.family.Board", "Board");
  predicateValueMap.put("com.hp.nms.incident.family.Connection", "Connection");
  predicateValueMap.put("com.hp.nms.incident.family.Correlation", "Correlation");
  predicateValueMap.put("com.hp.nms.incident.priority.Top", "Top");
  predicateValueMap.put("com.hp.nms.incident.priority.High", "High");
  predicateValueMap.put("com.hp.nms.incident.priority.Medium", "Medium");
  predicateValueMap.put("com.hp.nms.incident.priority.Low", "Low");
  predicateValueMap.put("com.hp.nms.incident.priority.None", "None");

%>

<style media="screen" type="text/css">
  span.forms-tab {
    display: inline;
    position: relative;
    top: -1px;
    z-index: 1;
    overflow: hidden;
    font-weight: bold;
  	text-decoration: none;
  	cursor: pointer;
    color: #333;
  	background: transparent url(/static/images/layout/main-menu-bg-off.gif) no-repeat top left;
  	padding: 6px 7px 1px 11px;
  	border-right: 1px solid #666;
    border-bottom: 1px solid #666;
    border-top: none;
    border-left: none;
    margin: 0;
  }

  span.forms-tab:hover {
    background: transparent url(/static/images/layout/main-menu-bg-hover.gif) no-repeat top left;
  }

  span.forms-tab.forms-activeTab {
  	display: inline;
    position: relative;
    top: 1px;
    z-index: 10;
    overflow: hidden;
  	cursor: default;
    color: #990033;
    background: transparent url(/static/images/layout/main-menu-bg-selected.gif) no-repeat top left;
    padding: 7px 7px 1px 11px;
    border-bottom: none;
  }

  span.forms-tab.forms-activeTab:hover {
  	background-color: #FFF;
  	position: relative;
  }

  span.forms-tabContent {
  	background-color: #FFF;
  	border: 1px solid #666;
  	/*padding: 3em;*/
  	position: relative;
  	z-index: 2;
  }

  #sandbag-01,
  #sandbag-02 {
  	clear: left;
  	float: left;
  	padding: 0pt; /*border: 1px solid #0f0;*/
  }

  #sandbag-01 {
  	height: 10px;
  	width: 160px;
  }

  #sandbag-02 {
  	height: 10px;
  	width: 95px;
  }

  label#matching {
  	font-weight: bold;
    width: 175px;
  }

  div.form-row label.summary {
  	font-weight: bold;
  	width: 0px;
  	float: none;
  	text-align: left;
  	vertical-align: middle;
  	padding: 0px 4px 0px 0px;
  	margin-left: 85px;
  }

  span.summary-row {
  	float: none;
  	text-align: left;
  	vertical-align: middle;
  	padding: 0px 0px 0px 0px;
  }

  span.summary-row span.summary-item {
  	float: none;
  	padding: 0px 5px 0px 0px;
  }

  span.elipse {
  	font-size: 11px;
  	color: #0000CC;
  	margin: 0px 0px 0px 5px;
  	padding: 0;
  	text-decoration: underline;
  	background-color: transparent;
  	border: none;
  	cursor: pointer;
  }

  div.form-row ul#summary_list {
  	margin-left: 100px;
  	padding: 0px 0px 0px 0px;
  }

  div.form-row ul#summary_list li {
  	display: list-item;
  	padding: 0px 3px 0px 0px;
  }

  div.form-row ul#summary_list li.summary_AND {
  	font-weight: bold;
  	list-style: none;
  	margin-left: 20px;
  }

  div.form-row ul#summary_list li.summary-item span.summary_text italic {
  	font-style: italic;
  }
</style>

<script type="text/javascript" language="JavaScript">
  var old_forms_showTab;
  function onLoad()
  {
   old_forms_showTab = forms_showTab;
   forms_showTab = new_forms_showTab;
   var lastTab = document.NNMSubscriptionForm.currentTab.value;
   if(window.location.hash == "#recipients")
     lastTab = 3;
   if(lastTab != null &amp;&amp; lastTab != "" &amp;&amp; lastTab != "null")
   forms_showTab("attributes", lastTab, 5, "");
  }
  
  function new_forms_showTab(tabgroup, idx, length, state)
  {
   document.NNMSubscriptionForm.currentTab.value = idx;
   old_forms_showTab(tabgroup, idx, length, state);
  }

  // form validation to ensure that all required predicates are supplied
  function validateForm(theForm)
  {
    if(selectedButtonId == "saveButton:input")
    {
      if (isBlank(theForm['name'].value))
      {
        alert('The Name ' + MSG_CustomRequiredField);
        theForm['name'].focus();
        selectedButtonId = "";
        return false;
      }
    }
    disableFormButtons(theForm);
    addFormField(theForm, 'hidden', selectedButtonId, requestedFormAction);
    return true;
  }

  // this is called by submitCloseChildSubmitParent
  function submitRefresh()
  {
    disableFormButtons(document.forms['NNMSubscriptionForm']);
    addFormField(document.forms['NNMSubscriptionForm'], 'hidden', 'refreshButton', 'refreshButton');
    setTimeout("document.forms['NNMSubscriptionForm'].submit()", 500);
  }

  function sortListPredicates(theForm)
  {
    for (var i = 0; i &lt; theForm.elements.length; i++)
    {
      if (theForm.elements[i].type == "select-multiple")
      {
        if ((theForm.elements[i].name).substr(0, 16) == "PREDICATE_VALUE_")
        {
          sortSelect(theForm.elements[i]);
        }
      }
    }
  }

</script>

<input type="hidden" name="currentTab" value="<%=request.getParameter("currentTab")%>" /> 

<text-widget id="name">
  <value><%= subscriptionBean.getName() %></value>
</text-widget>

<group label="Attributes">

  <tab-group id="attributes">
  
  <%
    if(!creatingSubscription)
    {
  %>

    <tab-content id="summary_tab" label="Summary">
      <div class="form-row">
        <label id="matching">Matching Any Event Where</label>
      </div>
      <div class="form-row">
      <ul id="summary_list">
<%
  iterator = subscriptionBean.getPredicateIterator();
  boolean firstNonEmptyPredicate = true;
  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     if(!predicate.getSelectedValues().isEmpty())
     {
       String summary = predicateSummaryNamesMap.get(predicate.getPredicateName());
	   if(summary.length() != 0) {
         if(!firstNonEmptyPredicate) { %>
           <li class="summary_AND">
             <span class="summary_text">AND</span>
           </li>
         <%}%>

          <li class="summary-item">
            <span class="predicate_data"><%=predicate.getPredicateName()%></span>
            <span class="summary_text italic"> <%=predicate.getSelectedOperatorType()%></span>
            <span class="predicate_data"> (<%=summary%></span>
            <% if(summary.length() == MAX_DISPLAY_CHARACTERS) { %>
            <span class="elipse" onclick="forms_showTab('attributes', '1', <%=Integer.toString(tabCount)%>, '')" >...</span>
            <% } %>
            <span class="summary_text">)</span>
          </li>
<%
	     firstNonEmptyPredicate = false;
	   }
     }
  }
%>
        </ul>
        </div>

        <div class="form-row">
          <label class="summary">Available:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.isOnSunday())
          {
            out.print("<span class=\"summary-item\">Sun</span>");
          }
          if(subscriptionBean.isOnMonday())
          {
            out.print("<span class=\"summary-item\">Mon</span>");
          }
          if(subscriptionBean.isOnTuesday())
          {
            out.print("<span class=\"summary-item\">Tue</span>");
          }
          if(subscriptionBean.isOnWednesday())
          {
            out.print("<span class=\"summary-item\">Wed</span>");
          }
          if(subscriptionBean.isOnThursday())
          {
            out.print("<span class=\"summary-item\">Thu</span>");
          }
          if(subscriptionBean.isOnFriday())
          {
            out.print("<span class=\"summary-item\">Fri</span>");
          }
          if(subscriptionBean.isOnSaturday())
          {
            out.print("<span class=\"summary-item\">Sat</span>");
          }
%>

          <span class="summary-item"><%=subscriptionBean.getStartTime()%></span>
          <span class="summary-item">-</span>
          <span class="summary-item"><%=subscriptionBean.getEndTime()%></span>
        </span>
        </div>
        <div class="form-row">
          <label class="summary">Using:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.hasAllDeviceFilter())
          {
            out.print("<span class=\"summary-item\">All Devices</span>");
          }
          else
          {
            ArrayList<String> types = subscriptionBean.getDeviceTypeOverrides();
            for(String type : types)
            {
%>
            <span class="summary-item"><%=type.substring(NotificationAPI.DEVICE_FILTER_FIELD_PREFIX.length())%></span>
<%
            }
          }
%>
          </span>
        </div>
<%
  if(!creatingSubscription && !subscriptionBean.isSelfSubscription())
  {
%>
        <div class="form-row">
          <label class="summary">Targeting:</label>
         <span class="summary-row">
<%
         int charactersDisplayed = 0;
         ArrayList<String> recipients = subscriptionBean.getRecipients();
         for(String recipient : recipients)
         {
%>
            <span class="summary-item"><%=recipient%></span>
<%
           charactersDisplayed += recipient.length();
           if(charactersDisplayed > MAX_RECIPIENT_DISPLAY_CHARACTERS)
           {
             out.print("<span class=\"summary-item\">...</span>");
             break;
           }
         }
%>
          </span>
        </div>

<%
  }
%>

    </tab-content>
    
<%
  }
%>

    <tab-content id="event_details" label="Event Details">
    <%
      Iterator<PredicateBean> iter = subscriptionBean.getListPredicateIterator();
      while(iter.hasNext())
      {
          final PredicateBean predicate = iter.next();
          String predicateName = predicate.getPredicateName();
          ArrayList<String> selectedValues = new ArrayList<String>();
          selectedValues.addAll(predicate.getSelectedValues());
          String displayPredicateName = predicateName;
          if (predicateLabelMap.containsKey(predicateName.toLowerCase())) {
              displayPredicateName = predicateLabelMap.get(predicateName.toLowerCase());
          }
    %>
          <multifield-grouping>
          <div class="form-row">
            <label class="widget" for="<%=predicate.getPredicateValueWidgetId()%>"><%=displayPredicateName%>:</label>
            <span  id="<%=predicate.getPredicateValueWidgetId()%>">
              <select
                    size="5"
                    multiple="0"
                    id="<%=predicate.getPredicateValueWidgetId()%>"
                    name="<%=predicate.getPredicateValueWidgetId()%>"
              >
    
                <option value="<%=subscriptionBean.getAnyPredicateListValue() %>"
    <%
              if(selectedValues.contains(subscriptionBean.getAnyPredicateListValue()))
                  out.print("selected=\"true\"");
    %>
                >-- ANY --
                </option>
    <%
              Collection<String> values;
              if (QUERY_SOURCENODE_PREDICATE_VALUES && predicateName.equalsIgnoreCase(SOURCENODENAME_PREDICATE_NAME)) {
                  values = nnmNodeServiceBean.getNodeNames();
              } else {
                  values = predicate.getPredicateValues();
              }
              for (String name : values)
              {
    %>
                <option value="<%= name%>"
    <%
                  if(selectedValues.contains(name)) {
                      out.print("selected=\"true\"");
                  }
                  String displayName = name;
                  if (predicateValueMap.containsKey(name)) {
                      displayName = predicateValueMap.get(name);
                  }
    %>
                >
                <%= displayName%>
                </option>
    <%
              }
    %>
               </select>
            </span>
          </div>
          </multifield-grouping>
    <% 
      }
    %>
    
    <%
      iter = subscriptionBean.getTextPredicateIterator();
      while(iter.hasNext())
      {
         final PredicateBean predicate = iter.next();
         String predicateName = predicate.getPredicateName();
          String displayPredicateName = predicateName;
          if (predicateLabelMap.containsKey(predicateName.toLowerCase())) {
              displayPredicateName = predicateLabelMap.get(predicateName.toLowerCase());
          }
         String selectedOperatorType = predicate.getSelectedOperatorType();
    %>
          <multifield-grouping>
            <pulldown-select id="<%=predicate.getOperatorWidgetId()%>"
                          label="<%=displayPredicateName%>:" force-label="true"
    <%
      if(selectedOperatorType != null)
      {
        out.print("value=\""+ selectedOperatorType +"\"");
      }
    %> >
    <%
      for (String operatorType : subscriptionBean.getValidOperatorTypeValues())
      {
%>
        <selection-item value="<%=operatorType%>" label="<%=operatorType%>" />
<%
      }
%>
            </pulldown-select>
            <span id="<%=predicate.getPredicateValueWidgetId()%>">
              <input type="text" size="20"
                     id="<%=predicate.getPredicateValueWidgetId()%>"
                     name="<%=predicate.getPredicateValueWidgetId()%>"
                     value="<%=predicate.getSelectedValue()%>" />
            </span>
            <span class="italic">Empty Field = Any Value</span>
          </multifield-grouping>

    
    <%
      }
%>


    </tab-content>

<%
  if(!subscriptionBean.allOverridesSuppressed() || !subscriptionBean.isTimeframeSuppressed())
  {
%>
    <tab-content id="pref_tab" label="Preferences">

      <subscription-timeframe group-label="Timeframe" />
      <subscription-overrides group-label="Overrides" />

    </tab-content>

<%
  }
%>

<%
  if(!subscriptionBean.isSelfSubscription())
  {
%>
    <tab-content id="assigned_tab" label="Assign">

      <subscribed-recipients group-label="Recipients" />

    </tab-content>
<%
  }
%>

</tab-group>

</group>

</subscription-panel>
